﻿define([
  "dojo/Deferred",
  "dojo/when",

  "epi/dependency"
], function (Deferred, when, dependency) {

  var _projectStore = null;
  var _projectService = null;

  function _getProjectStore() {
    if (_projectStore) {
      return _projectStore;
    }
    _projectStore = dependency.resolve("epi.storeregistry").get("epi.cms.project");
    return _projectStore;
  }

  function _getProjectService() {
    if (_projectService) {
      return _projectService;
    }
    _projectService = dependency.resolve("epi.cms.ProjectService");
    return _projectService;
  }

  function setProjectContext(projectId) {
    var projectStore = _getProjectStore();

    var def = new Deferred();
    when(projectStore.get(projectId)).then(function(project) {
      var projectService = _getProjectService();
      when(projectService.setCurrentProject(project)).then(function() {
        return def.resolve(project);
      });
    }.bind(this)).otherwise(function(e) {
      console.warn(`Cannot set project context for: '${projectId}'`, e);
      return def.resolve();
    });

    return def.promise;
  }
  return setProjectContext;
});
