﻿define(["epi/dependency"], function (dependency) {
  function getQueryStringParameter(parameterName) {
    var params = new URLSearchParams(window.location.search);
    return params.get(parameterName);
  }

  function parseHashValue(propertyName, index) {
    this._hashWrapper = this._hashWrapper || dependency.resolve("epi.shell.HashWrapper");
    var hash = this._hashWrapper.getHash();
    var parameterFromQuery;
    if (!hash || !hash[propertyName]) {
      // query string parameters will have priority over hash
      parameterFromQuery = getQueryStringParameter(propertyName);
      if (parameterFromQuery) {
        return parameterFromQuery;
      }

      return false;
    }

    var context = hash[propertyName].split(":///");
    if (context.length !== 2) {
      return false;
    }
    var hashValue = context[index];

    // if there is both query string and hash value and hash value
    // and hash value is different than query string (probably hash is root)
    // then use query string, otherwise hash is more important than querystring
    parameterFromQuery = getQueryStringParameter(propertyName);
    if (parameterFromQuery && parameterFromQuery !== hashValue) {
      return parameterFromQuery;
    }

    return hashValue;
  }

  function getContentLink() {
    return parseHashValue("context", 1);
  }

  function getProjectId() {
    return parseHashValue("project", 0);
  }

  return {
    getContentLink,
    getProjectId,
  };
});
